/*
 * MMC5603NJ.cpp
 *
 *  Created on: Oct 15, 2024
 *      Author: jswco
 */


#include <MMC5603.h>

void MMC5603::Init(MMC5603_CONFIG mmc5603_config){
	// MMC5603 Initialize
	mmc5603_config.addr = mmc5603_config.addr << 1;
	memcpy(&config, &mmc5603_config, sizeof(MMC5603_CONFIG));

	// Set Internal Control 1
	uint8_t data[2] = {MMC5603_INTERNAL_CONTROL1, 0};
	data[1] = 0;
	if(config.odr <= 75){
		data[1] |= 0x00;
	}else if(config.odr <= 150){
		data[1] |= 0x01;
	}else if(config.odr <= 255){
		data[1] |= 0x02;
	}
	HAL_I2C_Master_Transmit(&config.i2c, config.addr, data, 2, config.timeout);
}
uint8_t MMC5603::getDeviceId(){
	// 디바이스 ID 리턴
	uint8_t regAddr = ICM42688_WHO_AM_I, deviceId = 0;
	uint16_t error = 0;
	error = HAL_I2C_Master_Transmit(&config.i2c, config.addr, &regAddr, 1, 1000);
	if(error != HAL_OK){
		return 0;
	}
	error = HAL_I2C_Master_Receive(&config.i2c, config.addr, &deviceId, 1, 1000);
	if(error != HAL_OK){
		return 0;
	}
	return deviceId;
}
int32_t *MMC5603::getRawMag(){

}
bool MMC5603::isReady(){

}
